Jak nainstalovat Python 3.3?

103

Stažil jsem Python 3.3 z oficiálního webu, ale nemám ponětí, jak ho nainstalovat.

Používám Ubuntu 12.04

    
dané gonewild 18.01.2013 08:59

8 odpovědí

112

Python 3.3 byl propuštěn 29. září 2012, několik měsíců po Ubuntu 12.04 byl propuštěn. Je zahrnut v Ubuntu 12.10 ačkoli jakopython3.3 balíček

Pokud chcete nainstalovat Python 3.3 na verzi Ubuntu, která ji nemá ve svých úložištích, máte následující možnosti:

Použijte PPA

Existuje PPA obsahující staré a nové verze Pythonu , které udržuje Felix Krull. Podívejte se na odpověď Luper Rouch pro pokyny k instalaci.

Kompilace Pythonu ze zdroje

Toto je velmi snadné a umožňuje vám mít několik verzí Pythonu, aniž byste museli přemýšlet se systémovým překladačem pythonu (který je používán mnoha programy Ubuntu). Na mém dev stroje mám doslova desítky různých verzí Pythonu od 2,4 do 3,2 žijící šťastně v/opt.

musíme kompilátor C a další věci kompilovat Python

sudo apt-get install build-essential

SQLite libs musí být nainstalována, aby Python mohl mít podporu SQLite.

sudo apt-get install libsqlite3-dev
sudo apt-get install sqlite3 # for the command-line client
sudo apt-get install bzip2 libbz2-dev

Stažení a kompilace Pythonu:

wget http://www.python.org/ftp/python/3.3.5/Python-3.3.5.tar.xz
tar xJf ./Python-3.3.5.tar.xz
cd ./Python-3.3.5
./configure --prefix=/opt/python3.3
make && sudo make install

Několik pěkných dotek instalace příkazupy vytvořením symbolického odkazu:

mkdir ~/bin
ln -s /opt/python3.3/bin/python3.3 ~/bin/py

Alternativně můžete nainstalovat alias bash s názvempy místo:

echo 'alias py="/opt/python3.3/bin/python3.3"' >> .bashrc

A to je to. Nyní můžete mít libovolnou Python verzi, dokonce i alfa, nebo řekněme, abyste měli několik kopií Pythonu 3.3 kompilovaných s různými nastaveními ... ne to, že mnoho lidí to potřebuje ačkoli:)

Použijte pyenv

Existuje software nazvaný pyenv , který vám může pomoci automatizovat proces - to, co v podstatě dělá, je kompilace Pythonu ze zdroje, instalace ve svém domovském adresáři. Jeho cílem je pomoci vám spravovat více verzí Pythonu.

    
odpověděl Sergey 13.04.2017 14:25
43

Zde je to, co jsem udělal nainstalovat Python 3.3 na Ubuntu 12.04:

  1. Instalace závislostí:

    sudo apt-get build-dep python3.2
    sudo apt-get install libreadline-dev libncurses5-dev libssl1.0.0 tk8.5-dev zlib1g-dev liblzma-dev
    
  2. Stáhněte si Python 3.3.0:

    wget http://python.org/ftp/python/3.3.0/Python-3.3.0.tgz
    
  3. Výpis:

    tar xvfz Python-3.3.0.tgz
    
  4. Konfigurace a instalace:

    cd Python-3.3.0
    ./configure --prefix=/opt/python3.3
    make  
    sudo make install
    
  5. Otestujte, zda funguje:

    /opt/python3.3/bin/python3
    

Měli byste vidět něco podobného:

Python 3.3.0 (default, Jan 31 2013, 18:37:42) 
[GCC 4.6.3] on linux
Type "help", "copyright", "credits" or "license" for more information.
>>> 

Některé další věci, které jsou užitečné ... můžete ve svém domě vytvořit virtuální prostředí a na vyžádání aktivovat Python 3.3.

  1. Vytvořte virtuální prostředí ve svém domě:

    /opt/python3.3/bin/pyvenv ~/py33
    
  2. Aktivujte funkci virtualenv:

    source ~/py33/bin/activate
    
  3. Nainstalujte nástroje pro distribuci:

    wget http://python-distribute.org/distribute_setup.py
    python distribute_setup.py
    
  4. Instalace pip:

    easy_install pip
    
  5. Nainstalujte libovolné pythonové balíčky (tj. láhev)

    pip install bottle
    

Vychutnejte si!

    
odpověděl Boolean 01.02.2013 00:48
35

deadsnakes PPA obsahuje balíčky pro staré a nové verze pythonu:

sudo apt-get install python-software-properties
sudo add-apt-repository ppa:deadsnakes/ppa
sudo apt-get update
sudo apt-get install python3.3
    
odpověděl Luper Rouch 03.05.2013 21:52
9

Ubuntu 14.04 a dřívější:

Python2.7 je standardní. Správce balíčků používá instalaci python3 navíc nad běžným pythonem na Ubuntu, Ubuntu dokáže zpracovat oba 2,7 a 3,2 současně bez virtualenv:

sudo apt-get install python3
python3 --version
Python 3.2.3
python --version
Python 2.2.3

Ubuntu 18.04:

Python3 je standardně dodáván s operačním systémem a Python2.7 není k dispozici, dokud neinstalujete.

Tři názvy balíčků na výběr:python,python-minimal,python-all. Výchozí nastavení je minimální. Tato slova jsou jen příznaky úložišť Ubuntu, které obsahují další věci nebo ne. Chcete-li zjistit přesně, jaké jsou dílčí balení a které nejsou zahrnuty, vyhledejte další dílčí balíčky: Odkaz

sudo apt install python-minimal
python --version

Nebo zkuste inovovat python3:

sudo apt install python3-minimal
python --version

Chcete-li vynutit konkrétní verzi, můžete zkusit předat parametr verze:

sudo apt-get install python 3.3.3
    
odpověděl Eric Leschinski 25.12.2013 09:06
1

Pro každého, kdo má zájem, jsem napsal podrobnější podrobný článek o tom, jak nainstalovat Python 3.3.2 lokálně ze zdroje na Ubuntu 12.04, většinou založený na čtení @ vynikající odpověď sergey: Odkaz

    
odpověděl James Nicholson 12.11.2013 08:49
1

Napsal jsem skript, který automatizuje stahování, kompilaci a instalaci verzí Pythonu bez balíku. Skript nainstaluje verzi Pythonu v/opt bezpečně mimo správce balíčků a systémové verze Pythonu.

Dokonce získává závislost i pro většinu verzí Ubuntu. Měla by pracovat na všech aktuálně podporovaných verzích Ubuntu (10.04, 12.04, 12.10 a 13.04) a pravděpodobně iv jiných verzích.

Zařadím jej níže a zveřejnil jsem ho také na mém úložišti Github , což je hlavní umístění.

Skript by měl být zkopírován a ukládán do textového editoru, například jakobuild_python a proveden spustitelný (chmod u+x build_python) a pak může být spuštěn se dvěma parametry, kde první parametr musí být vždy větev Pythonu , a druhý parametr musí být vždy verze Pythonu.

Podívejte se na python.org pro výpisy verze, kterou chcete kompilovat.

Zde je několik příkladů využití skriptu:

  1. Pro stabilní vydání, po kontrole záznamů, může být spuštěn jako

    ./build_python '3.3.2' '3.3.2'
    
  2. Pro vývojové vydání, kde jsou dva parametry v seznamu odlišné, lze jej spustit jako:

    ./build_python '3.4.0' '3.4.0a1'
    

Tělo skriptu je uvedeno níže (zde není zvýrazněna syntaxe.) K tomu viz stránka Github a>:

#!/usr/bin/env bash

# by mik, aka Exactus29, https://github.com/Exactus29
# 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

##########

# a script to compile the latest stable version of Python and place in /opt

(( $# == 2 )) || { printf "Please provide a version branch (e.g. 3.4.0) and a version release (e.g. 3.4.0a1) in that order.\n"
                   printf "The official site is python.org, see the ftp server at: http://python.org/ftp/python.\n" >&2 ; exit 1; }

# a splew of variables, so that just the version number can be given on the cmd line
# and then then the script can do the rest, including verifying the packages using gpg

# need different branch and version as sometimes the two are different, particularly for dev releases
py_branch=""
py_version=""
shift 2

# check if install target already exists in /opt, and exit so user can decide what to do
if [[ -d /opt/python-${py_version} ]]; then 
    printf "Target directory for the build already exists, please rename or remove.\n" >&2
    exit 1
else 
    :
fi

# use tar.bz2 as that is what most of the older releases used, i.e. in case user tries to build an older release
py_url="http://python.org/ftp/python/${py_branch}/Python-${py_version}.tar.bz2"
py_asc="http://python.org/ftp/python/${py_branch}/Python-${py_version}.tar.bz2.asc"
py_dir="$HOME/src/python_build" # checked to exist later, etc

# first check if user requested file exists on server
wget --spider ${py_url} >/dev/null 2>&1
(( $? > 0 )) && printf "No such version, version ${py_version} does not exist\n" >&2 && exit 1


# now very important before we do anything else, to check if asc file exists, as it  doesn't for some downloads
# if we don't check and it doesn't exist it causes the script to exit

wget --spider ${py_asc} >/dev/null 2>&1
# set a flag re whether asc file exists, so can check later and avoid problems
(( $? > 0 )) && no_asc=1 || no_asc=0

# set up more variables
py_tarbz2="${py_url##*/}"
(( no_asc == 0 )) && py_tarbz2_asc="${py_asc##*/}" # only set this if there is an asc file
py_folder="${py_tarbz2%.*.*}"
py_gpg_key="" 

# check other build dependencies are installed, beyond build-dep, sqlite support, readline, ncurses, build-essential 
dependencies_check() {

    local installed=()
    local to_be_installed=()
    local dependencies_list=(build-essential wget libreadline-dev libncurses5-dev libssl1.0.0 tk8.5-dev zlib1g-dev liblzma-dev
libsqlite3-dev sqlite3 bzip2 libbz2-dev)    

    for package in "${dependencies_list[@]}"; do 
        if grep -iq '^ii' < <(dpkg -l "$package"); then
            installed+=("$package")
        else 
            to_be_installed+=("$package")
        fi
    done 2>/dev/null

    if (( ${#to_be_installed[@]} > 0 )); then
        printf "If you have recently elevated your privileges with sudo, you will not see a " 
        printf "prompt here, before the apt-get update and install of packages occurs.\n" 
        sleep 2
        sudo -p "We need to install some dependencies, please enter your password: " apt-get update && sudo apt-get -y install "${to_be_installed[@]}"
        return 0
    else 
        printf "\nNothing to install, proceeding.\n"
        return 0
    fi

}

# tailor build-dep to new python version we want to build, basically either 2x or 3x versions
# should work with at least lucid/precise/quantal/raring/saucy, the currently supported versions
if (( ${py_branch:0:1} == 3 )) && grep -iq 'precise' /etc/lsb-release 2>/dev/null; then
    sudo -p "Please provide your password to install dependencies: " apt-get build-dep python3.2 && dependencies_check
elif (( ${py_branch:0:1} == 3 )) && grep -Eiq '(raring|quantal|saucy)' /etc/lsb-release 2>/dev/null; then
    sudo -p "Please provide your password to install dependencies: " apt-get build-dep python3.3 && dependencies_check
elif [[ ${py_branch:0:3} == 2.7 ]] && grep -iq 'lucid' /etc/lsb-release 2>/dev/null; then
    sudo -p "Please provide your password to install dependencies: " apt-get build-dep python2.6 && dependencies_check
elif [[ ${py_branch:0:3} == 2.7 ]]; then
    sudo -p "Please provide your password to install dependencies: " apt-get build-dep python2.7 && dependencies_check
else
    printf "\nProceeding, but make sure you have the correct build deps installed.\n\n"
    sleep 2        
fi

# dir checks
if [[ -d $HOME/src ]]; then 
    cd $HOME/src || exit 1
else
    mkdir $HOME/src && cd $HOME/src
fi

if [[ -d ${py_dir} ]]; then
    mv "${py_dir}" "${py_dir}_old_$(date '+%F_%H_%M_%S')"
    mkdir "${py_dir##*/}" && cd "${py_dir##*/}"
else
    mkdir "${py_dir##*/}" && cd "${py_dir##*/}"
fi

# finally, download python 
printf "\nNow downloading version ${py_version} from branch ${py_branch} ....."
wget "${py_url}" -P "${py_dir}" >/dev/null 2>&1
(( $? == 0 )) && printf "Done.\n"
# only download asc if it exists, set flag earlier
(( no_asc == 0 )) && wget "${py_asc}" -P "${py_dir}" >/dev/null 2>&1

# gpg tests

gpg_test() {
    # if error returned, extract gpg key from error message
    py_gpg_key="$(gpg --verify "${py_tarbz2_asc}" "${py_tarbz2}" 2>&1 | awk '{ print $NF }' | grep -v found)"

    # now check with gpg_key (should be Python release signing key)
    printf "\nReceiving keys.. "
    gpg --recv-keys "${py_gpg_key}" >/dev/null 2>&1
    (( $? > 0)) && printf "Key could not be received\n" || printf "Done.\n"

    printf "\nVerifying download... "
    gpg --verify "${py_tarbz2_asc}" "${py_tarbz2}" >/dev/null 2>&1
    (( $? > 0 )) && printf "The download could not be verified.\n" || printf "Done.\n"

}

if (( no_asc == 0 )); then
    gpg --verify "${py_tarbz2_asc}" "${py_tarbz2}" >/dev/null 2>&1
    if (( $? > 0 )); then 
        gpg_test 
    else
        printf "\nDownload verified\n\n"
    fi
else
    printf "\nProceeding even though asc file is not available for gpg to verify download\n\n"
    sleep 1
fi

# unpack and cd to the python folder
printf "Unpacking archive...."
tar xvjf "${py_folder}.tar.bz2" >/dev/null 2>&1
(( $? == 0 )) && printf "Done.\n" || { printf "Problems occured when unpacking, exiting\n" >&2; exit 1; }
cd "${py_folder}" || exit 1

# tailor the build to your machine here with configure and make

printf "\nNow for the configure (default prefix is /opt/python-${py_version})...."
sleep 2
./configure --prefix=/opt/python-${py_version} >/dev/null 2>&1
# as configure and make will exit anyway on error, no need to add || alternatives to the tests below
(( $? == 0 )) && printf "Done.\n\n"  
sleep 1

printf "\nNow for the compile. (If necessary, please add your own specifications to the make command line and run the script again)\n"
printf "\nPlease wait for the compile to finish: it may take a while...."
make >/dev/null 2>&1
(( $? == 0 )) && printf "Done.\n\n"

printf "\nWe are installing with make install into /opt, instead of using checkinstall.\n"
sudo make install >/dev/null 2>&1
installcode=$?
(( $installcode == 0 )) && printf "\n${py_version} succesfully installed in /opt/python-${py_version}\n\n"

if [[ -d $HOME/bin ]]; then
    ln -s /opt/python-${py_version}/bin/python${py_version:0:3} ~/bin/py-${py_version}
    (( $? == 0 )) && printf "\nSymlink created, run py-${py_version} in the terminal to launch the interpreter\n"
else
    mkdir $HOME/bin && ln -s /opt/python-${py_version}/bin/python${py_version:0:3} ~/bin/py-${py_version}
    (( $? == 0 )) && printf "\nSymlink created, run py-${py_version} in the terminal to launch the interpreter\n"
    printf "\nHowever, you will not be able to call py-${py_version} until you have logged out and in again, as bin will not"
    printf " have been added to your path just as $HOME/bin is created.\nn"
fi

# important info re setting up pyvenv re distribute tools and pip etc
cat <<extra_info

            See also a program called pyvenv with your installation in /opt, 
            with which you can create a virtual environment and use tools
            such as pip, etc. See the official documentation at:
            http://docs.python.org/3.3/using/scripts.html#pyvenv-creating-virtual-environments

extra_info

sleep 2 
exit ${installcode}
    
odpověděl user76204 14.09.2013 12:13
1

Varování : Pythonbrew byl zastán ve prospěch pyenv. Aktualizované pokyny jsou zde

Můžete také použít něco jako pythonbrew :

curl -kL http://xrl.us/pythonbrewinstall | bash    
echo "[[ -s $HOME/.pythonbrew/etc/bashrc ]] && source $HOME/.pythonbrew/etc/bashrc" >> ~/.bashrc    
pythonbrew install 3.3

Je to velmi snadné použití a další výhoda, že je možné nainstalovat libovolnou verzi Pythonu, kterou potřebujete. Přečtěte si dokumenty o podrobnostech režimu

    
odpověděl Alexey Savanovich 24.01.2013 07:24
0

Zde jsou kroky, které jsem následoval:

wget http://python.org/ftp/python/3.3.2/Python-3.3.2.tar.bz2
tar -xvjf ./Python-3.3.2.tar.bz2
cd ./Python-3.3.2
./configure --prefix=/opt/python3.3
make && make install
mkdir ~/bin
ln -s /opt/python3.3/bin/python ~/bin/py
echo 'alias py="/opt/python3.3/bin/python3"' >> .bashrc
    
odpověděl Tarun 03.09.2013 07:51